
/* ----------------------------------------------------------------------
   The SINUS Firewall -- a TCP/IP packet filter for Linux

   Written within the SINUS project at the University of Zurich,
   SWITCH, Telekurs Payserv AG, ETH Zurich.
   originally based on the sf Firewall Software (C) 1996 by Robert
   Muchsel and Roland Schmid.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   SINUS Firewall resources:
   SINUS Homepage: http://www.ifi.unizh.ch/ikm/SINUS/
   Firewall Homepage: http://www.ifi.unizh.ch/ikm/SINUS/firewall.html
   Frequently asked questions: http://www.ifi.unizh.ch/ikm/SINUS/sf_faq.html
   Mailing list for comments, questions, bug reports: firewall@ifi.unizh.ch
   ----------------------------------------------------------------------  */



package sfclasses;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Enumeration;
import java.io.*;
import corejava.*;

// graphical panel to edit an address list
class AddrPanel extends Panel implements ActionListener {
    static java.util.ResourceBundle clientRes = java.util.ResourceBundle.getBundle("ClientResource")/*#BundleType=List*/;

  public AddrPanel(AddrList al) {
    // implicit super() call

    AddrListObj = al;

    GridBagLayout gbl = new GridBagLayout();
    setLayout(gbl);
    
    addrlbox = new List(5, false);
    Enumeration en = al.getAddresses().elements();
    AddrObj adr;
    while (en.hasMoreElements()) {
      adr = (AddrObj)en.nextElement();
      addrlbox.add(adr.toString());
    }
    addbut = new Button(clientRes.getString("Add"));
	 addbut.addActionListener(this);
    removebut = new Button(clientRes.getString("Remove"));
	 removebut.addActionListener(this);
    addrtext = new TextField();
    addrlabel = new Label(clientRes.getString("Address:"));
    masktext = new TextField();
    masklabel = new Label(clientRes.getString("Netmask:"));

    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = GridBagConstraints.BOTH;
    Utils.add_component(this, addrlbox, gbl, gbc, 0, 0, 4, 5, 100, 100);
    gbc.fill = GridBagConstraints.NONE;
    Utils.add_component(this, addbut, gbl, gbc, 2, 5, 1, 1, 0, 0);
    Utils.add_component(this, removebut, gbl, gbc, 1, 5, 1, 1, 0, 0);
    gbc.fill = GridBagConstraints.BOTH;
    Utils.add_component(this, addrlabel, gbl, gbc, 0, 6, 1, 1, 0, 0);
    Utils.add_component(this, addrtext, gbl, gbc, 1, 6, 3, 1, 100, 0);
    Utils.add_component(this, masklabel, gbl, gbc, 0, 7, 1, 1, 0, 0);
    Utils.add_component(this, masktext, gbl, gbc, 1, 7, 3, 1, 100, 0);
    addrtext.requestFocus();
  }

  public void actionPerformed(ActionEvent ae) {
  Object source = ae.getSource();

	 // Process addbut
    if (source == addbut) {
      String str;
      if (masktext.getText().trim().length() == 0)
        str = addrtext.getText().trim();
      else
        str = addrtext.getText().trim() + "/" + masktext.getText().trim()/*#Frozen*/;
      AddrObj ao = new AddrObj(str);
      if (ao.getAddr() == null) {
        UserDialog.ErrorBox(java.text.MessageFormat.format(
                clientRes.getString("Invalid IP address or host name:\n{0}"),
                new String[]{"" + str}));
        return;
      }
      if (AddrListObj.getAddresses().contains(ao)) {
        int sel = AddrListObj.getAddresses().indexOf(ao);
        addrlbox.remove(sel);
      }
      AddrListObj.addAddress(ao);
      addrlbox.add(ao.toString());
      return;
    }

	 // Process removebut
    else if (source == removebut) {
      int sel = addrlbox.getSelectedIndex();
      if (sel == -1) // nothing selected
        return;
      AddrListObj.getAddresses().removeElementAt(sel);
      addrlbox.remove(sel);
      return;
    }
  } // actionPerformed

  private AddrList AddrListObj;
  private List addrlbox;
  private Button addbut;
  private Button removebut;
  private TextField addrtext;
  private TextField masktext;
  private Label addrlabel;
  private Label masklabel;
}